#ifndef cppdemo
#define cppdemo cppdemo

#pragma pack(1)

/*************************************************
 *                                               *
 *       Einfache Demo-DLL fr BORIS             *
 *       (Beispiel 1 des Handbuchs)              *
 *                                               *
 *************************************************/

#ifdef _MSC_VER
#define WFCallingConvention  __stdcall
#elif  __BORLANDC__
#define WFCallingConvention  _stdcall _export
#endif


typedef struct{
    char NuE;                    //Anzahl reeller Zahlenwerte
    char NuI;                    //Anzahl ganzer Zahlenwerte
    char NuB;                    //Anzahl Schalter
    NUMType E[32];           //reelle Zahlenwerte
    int I[32];               	 //ganze Zahlenwerte
    char B[32];               	 //Schalter
    char D[256];                 //event. Dateiname fr weitere Daten.
    NUMType EMin[32];        //untere Eingabegrenze fr jeden reellen Zahlenwert
    NUMType EMax[32];        //obere Eingabegrenze fr jeden reelen Zahlenwert
    int IMin[32];         	 //untere Eingabegrenze fr jeden ganzzahligen Zahlenwert
    int IMax[32];         	 //obere Eingabegrenze fr jeden ganzzahligen Zahlenwert
    char NaE[32][41];     	 //Namen der reelen Zahlenwerte
    char NaI[32][41];     	 //Namen der ganzen Zahlenwerte
    char NaB[32][41];     	 //Namen der Schalter
   /*den Rest der Variablen von TParameterStruct knnen wir uns sparen,
     da wir ihn nicht bentigen!  */
  } TParameterStruct, *PParameterStruct;

typedef struct {
    long AllowE;            //Soll die Eingabe eines Wertes
    long AllowI;            //un-/zulssig sein so ist das Bit
    long AllowB;            //des Allow?-Feldes 0 bzw. 1
    char AllowD;
  } TDialogEnableStruct, *PDialogEnableStruct;


typedef struct {
    char Inputs;                 //Anzahl Eingnge
    char Outputs;                //Anzahl Ausgnge
    char NameI[50][41];
    char NameO[50][41];
  } TNumberOfInputsOutputs, *PNumberOfInputsOutputs;

typedef NUMType TInputArray[10];
typedef NUMType TOutputArray[10];

#pragma pack()

extern "C"
{
  void  WFCallingConvention GetParameterStruct(PParameterStruct);
  void  WFCallingConvention GetDialogEnableStruct(PDialogEnableStruct,PParameterStruct);
  void  WFCallingConvention GetNumberOfInputsOutputs(PNumberOfInputsOutputs D);
  int   WFCallingConvention CanSimulateDLL(PParameterStruct D);
  void  WFCallingConvention InitSimulationDLL(PParameterStruct D,TInputArray Inputs,TOutputArray Outputs);
  void  WFCallingConvention SimulateDLL(NUMType T,PParameterStruct D,TInputArray Inputs,TOutputArray Outputs);
  char* WFCallingConvention SetInputChar(void);
  void  WFCallingConvention EndSimulationDLL(void);
  void  WFCallingConvention IsUserDLL32(void);
}

#endif